# Theming Guide

> **See also**
>
> [Getting started]()
>
>   If you just want to do some simple customizations such as changing the title of your CKAN site, or making some small CSS customizations, [Getting started]() documents some simple configuration settings you can use.

> **Note**
>
> Before you can start developing a CKAN theme, you’ll need a working source install of CKAN on your system. If you don’t have a CKAN source install already, follow the instructions in [Installing CKAN from source]() before continuing.
> 

> **Note**
>
> CKAN theme development is a technical topic, for web developers. The tutorials below assume basic knowledge of:
> - The Python programming language
> - HTML
> - CSS
> - JavaScript
>
> We also recommend familiarizing yourself with:
> - Jinja2 templates
> - Bootstrap
> - jQuery

> **Note**
> 
> Starting from CKAN version 2.10 the Bootstrap version used in the default CKAN theme is Bootstrap 5. For backwards compatibility, Bootstrap 3 templates will be included in CKAN core for a few versions, but they will be eventually removed so you are encouraged to update your custom theme to use Bootstrap 5. You can select which set of templates to use (Bootstrap 5 or 3) by using the [ckan.base_public_folder]() and [ckan.base_templates_folder]() configuration options.

## Customizing CKAN’s templates
CKAN pages are generated from Jinja2 template files. This tutorial will walk you through the process of writing your own template files to modify and replace the default ones, and change the layout and content of CKAN pages.

> **Note**
> 
> [String internationalization]()
> 
>  How to mark strings for translation in your template files.

### Creating a CKAN extension
A CKAN theme is simply a CKAN plugin that contains some custom templates and static files, so before getting started on our CKAN theme we’ll have to create an extension and plugin. For a detailed explanation of the steps below, see [Writing extensions tutorial]().

- Use the `ckan generate extension` command as per the [Writing extensions tutorial]().
- Create the file `ckanext-example_theme/ckanext/example_theme/plugin.py` with the following contents:

```python
# encoding: utf-8

import ckan.plugins as plugins

class ExampleThemePlugin(plugins.SingletonPlugin):
    '''An example theme plugin.

    '''

    pass
```
    
- Edit the entry_points in `ckanext-example_theme/setup.py` to look like this:

```python
entry_points='''
    [ckan.plugins]
    example_theme=ckanext.example_theme.plugin:ExampleThemePlugin
'''
```

- Run `python setup.py develop`:

```
cd ckanext-example_theme
python setup.py develop
```

- Add the plugin to the `ckan.plugins` setting in your /etc/ckan/default/ckan.ini file:

```
ckan.plugins = stats text_view datatables_view example_theme
```

- Start CKAN in the development web server:

```
$ ckan -c /etc/ckan/default/ckan.ini run
Starting server in PID 13961.
serving on 0.0.0.0:5000 view at http://127.0.0.1:5000
```

Open the CKAN front page in your web browser. If your plugin is in the ckan.plugins setting and CKAN starts without crashing, then your plugin is installed and CKAN can find it. Of course, your plugin doesn’t do anything yet.

### Replacing a default template file
Every CKAN page is generated by rendering a particular template. For each page of a CKAN site there’s a corresponding template file. For example the front page is generated from the [ckan/templates/home/index.html]() file, the `/about` page is generated from [ckan/templates/home/about.html](), the datasets page at `/dataset` is generated from [ckan/templates/package/search.html](), etc.

To customize pages, our plugin needs to register its own custom template directory containing template files that override the default ones. Edit the `ckanext-example_theme/ckanext/example_theme/plugin.py` file that we created earlier, so that it looks like this:

```python
# ... ckanext-example_theme/ckanext/example_theme/plugin.py
# encoding: utf-8

'''plugin.py

'''
from ckan.common import CKANConfig
import ckan.plugins as plugins
import ckan.plugins.toolkit as toolkit


class ExampleThemePlugin(plugins.SingletonPlugin):
    '''An example theme plugin.

    '''
    # Declare that this class implements IConfigurer.
    plugins.implements(plugins.IConfigurer)

    def update_config(self, config: CKANConfig):

        # Add this plugin's templates dir to CKAN's extra_template_paths, so
        # that CKAN will use this plugin's custom templates.
        # 'templates' is the path to the templates dir, relative to this
        # plugin.py file.
        toolkit.add_template_directory(config, 'templates')
```

This new code does a few things:

- It imports CKAN’s [plugins toolkit]() module:

```
import ckan.plugins.toolkit as toolkit
```

    The plugins toolkit is a Python module containing core functions, classes and exceptions for CKAN plugins to use. For more about the plugins toolkit, see [Writing extensions tutorial]().

- It calls `implements()` to declare that it implements the `IConfigurer` plugin interface:

```
    plugins.implements(plugins.IConfigurer)
```

    This tells CKAN that our `ExampleThemePlugin` class implements the methods declared in the `IConfigurer` interface. CKAN will call these methods of our plugin class at the appropriate times.

-  





## Adding static files
